# -*- coding: utf-8 -*-
# Generated by Django 1.11.5 on 2017-10-05 09:12
from __future__ import unicode_literals

from django.db import migrations

def migrer_artiste(apps, schema):
    # On récupère les modèles
    Morceau = apps.get_model('musiques', 'Morceau')
    Artiste = apps.get_model('musiques', 'Artiste')

    # On récupère les artistes déjà enregsitrés dans la table Morceau
    # Voir la documentation :
    # - https://docs.djangoproject.com/fr/1.11/ref/models/querysets/#all
    # - https://docs.djangoproject.com/fr/1.11/ref/models/querysets/#values
    # - https://docs.djangoproject.com/fr/1.11/ref/models/querysets/#distinct
    artistes = [fields['nom'] for fields in Artiste.objects.all().values('nom').distinct()]
    morceaux = Morceau.objects.all()
    # On peuple la table Artiste
    for m in morceaux:
        var = Artiste.objects.get(nom=m.artiste)
        m.artiste_2 = var
        m.save()


def annuler_migrer_artiste(apps, schema):
    Morceau = apps.get_model('musiques', 'Morceau')
    Artiste = apps.get_model('musiques', 'Artiste')

    artistes = [fields['nom'] for fields in Artiste.objects.all().values('nom').distinct()]
    morceaux = Morceau.objects.all()
    # On peuple la table Artiste
    for m in morceaux:
        var = Artiste.objects.get(nom=m.artiste)
        m.artiste_2 = None
        m.save()

class Migration(migrations.Migration):

    dependencies = [
        ('musiques', '0005_morceau_artiste_2'),
    ]

    operations = [
        migrations.RunPython(migrer_artiste, reverse_code=annuler_migrer_artiste)
    ]
